#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <malloc.h>
#include <conio.h>
#include <memory.h>
#include <string.h>

void shutdown(void)
{
   fcloseall();
}

void main(int argc, char **argv)
{
   if (argc != 3)
      {
      printf("Usage: asc in.ASCII out.TXT\n");
      exit(1);
      }

   FILE *in = fopen(argv[1],"rb");
   assert(in);

   FILE *out = fopen(argv[2],"wt");
   assert(out);

   atexit(shutdown);

   int n = 0;

   while (1)
      {
      unsigned short len=0;
      int result = fread(&len, 2, 1, in);

      if (result != 1)
         {
         break;
         }

      len = ((len & 0xff) << 8) + (len >> 8);
      int nch = len;

      if (len & 1) len++;

      if (len == 0)
         {
         break;
         }

      static char input_line[65536];

      assert(len < (int) sizeof(input_line)-1);

      result = fread(input_line, 1, len, in);
      assert(result == len);

      input_line[nch] = 0;
      strcat(input_line,"\n");

      result = fputs(input_line, out);
      assert(result >= 0);
      
      ++n;
      }

   printf("Done, %d lines converted\n",n);

}



